' %Z%%M%    %I%  %W%  %G%  %U%
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2005.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

On Error Resume Next
Err.Clear

Const wbemFlagReturnImmediately = &h10
Const wbemFlagForwardOnly = &h20
Dim keyItem
Dim OpenSSHdExecutable
Dim WqlQuery
Dim keyValue
Dim executableSSH

keyValue = obatainRegistryValue("HKLM\SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/\native")
WScript.echo "[HomeDirecotry:]  " & keyValue

url = "winmgmts:\\.\root\CIMV2"
WqlQuery = "SELECT ProcessId, ParentProcessId FROM Win32_Process WHERE ExecutablePath LIKE '%sshd.exe'"
WqlQuery = "SELECT * FROM Win32_Process WHERE Caption LIKE 'sshd.exe'"
WqlQuery = "SELECT * FROM Win32_Process"

Set objWMIService = GetObject(url)
Set colItems = objWMIService.ExecQuery(WqlQuery, "WQL", wbemFlagReturnImmediately + wbemFlagForwardOnly)

For Each objItem In colItems
	cmdLine = ""
	cmdLine = objItem.CommandLine
	If InStr(1, objItem.Caption, "sshd", 1) Then
		'some OS (ex. Win2000) does not support CommandLine property
		if cmdLine = "" then
			WScript.Echo "[ProcesPID]:" & objItem.ProcessId & " [ProcesParentPID]:" & objItem.ParentProcessId & " [CommandLine]:" & objItem.ExecutablePath & " [WARNING]: The command line could not be retrieved"
		else 
			WScript.Echo "[ProcesPID]:" & objItem.ProcessId & " [ProcesParentPID]:" & objItem.ParentProcessId & " [CommandLine]:" & cmdLine
		end if 
	End if
Next

Function obatainRegistryValue(regkey)
	On Error Resume Next
	value = getRegistryValue(regkey)
	OpenSSHdExecutable = value
	if Err.number=0 then
		obatainRegistryValue = value
	else
		obatainRegistryValue = "NOT INSTALLED"
		Wscript.Echo "[ERROR:" & Err.description & "]"
		Err.clear
	end if
End Function

Function getRegistryValue(regkey)
	On Error Resume Next
	set sh = Wscript.CreateObject("WScript.Shell")
	getRegistryValue = sh.RegRead(regkey)
End Function
